// SourceCode from http://www.felixgers.de/teaching/c-cpp/c-cpp_SmallCodeExamples.html

#include <iostream.h>
#include "keypressed.h"

struct termios term, termsave;

void tty_noncanonical(int fd) {
  if (tcgetattr(STDIN_FILENO, &termsave) < 0) cout << "get error" << endl;
  term = termsave;
  term.c_lflag &= ~(ICANON | ECHO ); // noncanonical and no echo 
  term.c_cc[VMIN] = 0; // buffer size
  term.c_cc[VTIME] = 0;
  if (tcsetattr(fd, TCSANOW, &term) < 0) 
    cout << "set error" << endl;  
}

void tty_reset(int fd) {
  if (tcsetattr(fd, TCSANOW, &termsave) < 0) 
    cout << "set error" << endl;  
}

char keypressed(char &ac) {
  int iReturnValue = 0;
  iReturnValue = read(STDIN_FILENO, &ac, 255);
  tcflush(STDIN_FILENO, TCIOFLUSH); // damit der Puffer nicht voll wird...
  return iReturnValue;
}
